
; CP vector intro

; Hardware registers

BLTSIZE		equ	$058
BLTAMOD		equ	$064
BLTBMOD		equ	$062
BLTDMOD		equ	$066
BLTAPTH		equ	$050
BLTBPTH		equ	$04c
BLTDPTH		equ	$054
BLTCON0		equ	$040
BLTCON1		equ	$042
BLTAFWM		equ	$044
BLTALWM		equ	$046
BLTADAT		equ	$074
BLTBDAT		equ	$072
BLTCPTH		equ	$048
BLTCMOD		equ	$060
BLTAPTL		equ	$052
DMACONR		equ	$002
DMACON		equ	$096

execbase	equ 	4
disable		equ	-120
enable		equ	-126
openlib		equ	-552
closelib	equ	-414

; Some vectors constants

P:		equ	100
OX:		equ	150
OY:		equ	80

		OPT	C+,O+

		SECTION	code,CODE_C

; The Captain Paranoia FAST intro starts here

Main:		movem.l	d0-d7/a0-a6,-(sp)
		lea	GfxName(pc),a1
		moveq	#0,d0
		move.l	(execbase).w,a6
		jsr	openlib(a6)
		move.l	d0,a1
		move.l	38(a1),CopSave	; Old copperlist
		jsr	closelib(a6)

		jsr	disable(a6)

		lea	$dff000,a5	; CUSTOM base

		clr.w	ErzFlag

		bsr	MakeSine	; Create sine table from cos

		lea	ScrollText(pc),a0
		move.w	#250,ScrollCnt
		move.l	a0,ScrollPos
; Nasty scrolltext decoding here



; Clear screen memory
		lea	screen,a0
		move.w 	#(screensize>>2)-1,d0
ClearLp:	clr.l	(a0)+
		dbf	d0,ClearLp

; Now a really tricky bit - decompressing the Logo BODY data

		lea	FASTBODY,a0	; Source
		lea	screen,a1	; Dest plane 1
		move.w	#199,d4		; 200 rows to decompress
RowLp:		moveq	#1,d3		; 2 bitplanes
		move.l	a1,a2		; Working row #
PlaneLp:	moveq	#0,d2		; BCnt%
InRow:		lea	(a2,d2.w),a3	; Address to copy to
		addq.w	#1,d2		; Both routines need this
		moveq	#0,d0		; BYTE -> WORD
		move.b	(a0)+,d0	; Incode
		bmi.s	ByteRun		; If less than 128, just copy
		add.w	d0,d2
CopyLp:		move.b	(a0)+,(a3)+
		dbf	d0,CopyLp	; Straight copy, len incode+1
		bra.s	NextBit
ByteRun:	move.w	#256,d1
		sub.w	d0,d1		; No. of bytes to fill
		add.w	d1,d2
		move.b	(a0)+,d0	; Byte to fill with
ByteRunLp:	move.b	d0,(a3)+
		dbf	d1,ByteRunLp	; Straight fill, len 257-incode
NextBit:	cmp.w	#40,d2
		blt.s	InRow		; If not whole line try again
		lea	16402(a2),a2	; Plane 3 when done plane one
		dbf	d3,PlaneLp	; Get next plane, do whole row
		lea	40(a1),a1	; Get next line of plane 1
		dbf	d4,RowLp	; Do all rows

; Now set up the copperlist bitplanes

		move.l	#screen,d0
		move.w	#$e0,d1
		lea	Copper(pc),a0
		moveq	#2,d2		; 3 planes to init
CopInit:	move.w	d1,(a0)+
		addq.w	#2,d1
		swap	d0
		move.w	d0,(a0)+
		swap	d0
		move.w	d1,(a0)+
		addq.w	#2,d1
		move.w	d0,(a0)+
		btst	#0,d2
		bne.s	EvenPlane
		add.l	#8002,d0
		bra.s	TheDBF
EvenPlane:	add.l	#8400,d0
TheDBF:		dbf	d2,CopInit

		lea	Copper(pc),a0
		lea	RealCopper,a1
		moveq	#17,d0
CopyCopper1:	move.l	(a0)+,(a1)+
		dbf	d0,CopyCopper1
		move.w	#199,d0
		lea	Colours(pc),a0
		move.w	#$2c0f,d1
CopyCopper2:	move.w	d1,(a1)+
		add.w	#$100,d1
		move.l	#$fffe0192,(a1)+
RedoCol:	move.w	(a0)+,(a1)+
		bne.s	ColOk
		lea	Colours(pc),a0
		move.w	(a0)+,-2(a1)
ColOk:		dbf	d0,CopyCopper2
		moveq	#-2,d0
		move.l	d0,(a1)+

		move.w	#$42f,DMACON(a5)	; Spr, Aud, bltpri DMA off
		move.w	#$83c0,DMACON(a5)	; en, bp, cop, blt DMA on

		move.l	#RealCopper,$80(a5)	; set copperlist

RunTime:	move.l	$4(a5),d0
		and.l	#$1ff00,d0
		cmp.l	#$08000,d0
		bne.s	RunTime		; Sync with VBeam

		bsr	Scroller

		moveq	#vert-1,d0
		lea	VData(pc),a0
		lea	PData(pc),a1
MoveLp:		move.l	(a0)+,(a1)+
		move.w	(a0)+,(a1)+
		dbf	d0,MoveLp	; Copy data to safe

BeamWait2:	move.l	4(a5),d0
		and.l 	#$1ff00,d0
		cmp.l	#$0c000,d0
		bne.s	BeamWait2

		tst.w	ErzFlag
		bne.s	ErzNorm
		st	ErzFlag
		bra.s	NoErz
ErzNorm:	move.w	#$400,DMACON(a5) ; BLTPRI off
		bsr	EraseShape	; Erase shape if there is one

NoErz:		move.w	Ang(pc),d6
		subq.w	#2,d6
		and.w	#255<<1,d6	; steps of 2, 255 possibilities
		move.w	d6,Ang
COSR		EQUR	a4		; Register pointer to COS table
		lea	COS(pc),COSR	; COS base needed for rotates
SINER		EQUR	a3		; Register pointer to SINE table
		lea	SINE(pc),SINER	; SINE base needed for rotates
;		bsr	XAxis		; Rotate around x
		bsr	YAxis		; Rotate around y
		bsr	ZAxis		; Rotate around z

		move.w	#$8400,DMACON(a5) ; BLTPRI on
		bsr	CalcPos		; Calc pos and draw

		btst	#6,$bfe001
		bne	RunTime

		move.l	$4.w,a6
		jsr	enable(a6)

		move.l	CopSave(pc),$80(a5)
		move.w	#$8020,DMACON(a5)
		movem.l	(sp)+,d0-d7/a0-a6
		rts

; Now some well hard subroutines

Scroller:	subq.w	#1,ScrollCnt
		bne.s	DoScroll
		move.w	#8,ScrollCnt	; New letter
		move.l	ScrollPos(pc),a0
		moveq	#0,d0
WrapScroll:	move.b	(a0)+,d0
		bne.s	CharOK
		lea	ScrollText(pc),a0
		bra.s	WrapScroll
CharOK:		move.l	a0,ScrollPos		; Space for special char routines

		lea	Font-256(pc),a0
		lsl.w	#3,d0		; offset to char
		add.w	d0,a0		; a0=Char address
		lea	screen2+7265,a1	; 110 lines down

		moveq	#7,d0		; 8 lines
CharCopy:	move.b	(a0)+,(a1)
		lea	84(a1),a1	; Double height, double width
		dbf	d0,CharCopy

; Now the strange time-consuming scroller routine

DoScroll:	moveq	#7,d7		; 8 lines to scroll
		lea	screen2+6804,a1	; half screen

LineLp:		lea	COSHCORR(pc),a0	; End of cosh offset table
		moveq	#41,d5		; 42 bytes to rotate
ByteLp:		move.w	(a0),d6		; Too easy
		subq.l	#2,a0		; So much for (a0)-
		move.l	a1,a2
		add.w	d6,a2
		move.b	(a2),d0
		roxl.b	#1,d0
		move.b	d0,(a2)
		move.b	d0,42(a2)	; Double height
		dbf	d5,ByteLp
		lea	84(a1),a1
		dbf	d7,LineLp

		rts


; Now some routines for the 3d shape

CalcPos:	lea	PData(pc),a0
		lea	DData(pc),a1
		moveq	#vert-1,d7	; Number of points
CalcPosLp:	move.w	(a0)+,d0	; get x
		move.w	(a0)+,d1	; get y
		move.l	#P<<7,d2	; d2 = 128 P
		moveq	#P,d3		; d3 + P
		sub.w	(a0)+,d3	; d3 + (P-Z)
		divs	d3,d2		; d2 = 128P / (P-Z)
		muls	d2,d0
		muls	d2,d1		; use as scale factor for x and y
		asr.w	#6,d0
		asr.w	#6,d1		; divide by 128, multiply by 2
		add.w	#OX,d0
		add.w	#OY,d1		; add origins
		move.w	d0,(a1)+
		move.w	d1,(a1)+	; store in Ddata
		dbf	d7,CalcPosLp

		move.w	#$ffff,a2	; Set mask to 'draw'

DrawShape:	lea	DData(pc),a4
EraseEnt:	lea	EData(pc),a3
		moveq	#edge-1,d7
DrawLoop:	move.w	(a3)+,d4
		lsl.w	#2,d4
		move.w	(a4,d4.w),d0
		move.w	2(a4,d4.w),d1
		move.w	(a3)+,d4
		lsl.w	#2,d4
		move.w	(a4,d4.w),d2
		move.w	2(a4,d4.w),d3	; Get line coords to draw
		lea	screen2,a0
		bsr.s	DrawLine
		dbf	d7,DrawLoop	; Do all lines

aret		rts

; Routine to erase the shape, by wiping a block with the blitter

xerzs	equ	160		; x size to erase, in pixels
xerz	equ	(320-xerzs)>>1	; x pointer to erase, in pixels from left
yerz	equ	10		; y pointer to erase, lines from top
yerzs	equ	150		; y size to erase, lines

EraseShape:	btst	#14,DMACONR(a5)
		bne.s	EraseShape
		move.l	#screen2+(xerz>>3)+42*yerz,BLTDPTH(a5)
		move.w	#$0100,BLTCON0(a5)
		clr.w	BLTCON1(a5)
		move.w	#42-xerzs>>3,BLTDMOD(a5)
		move.w	#(yerzs<<6)+(xerzs>>4),BLTSIZE(a5)
		rts

; Now a line drawing routine nicked straight out of the system
; programmers guide 'cos I'm a lazy git - undoubtedly it's incredibly
; inefficient and wastes all the time I saved trying to optimise the rest.

; Parameters:
; d0-d1 are coords of start point
; d2-d3	are coords of end point
; a0=Bitplane first word
; a2=word for mask register
; d4 to d6 are used as work registers

DrawLine:	cmp.w	d0,d2
		bne.s	.ok
		cmp.w	d1,d3
		beq.s	aret		; routine messes up if no line

.ok		moveq	#42,d4		; Screen width in bytes
		mulu	d1,d4
		moveq	#-16,d5
		and.w	d0,d5
		lsr.w	#3,d5
		add.w	d5,d4
		add.l	a0,d4

		moveq	#0,d5
		sub.w	d1,d3
		roxl.b	#1,d5
		tst.w	d3
		bge.s	y2gy1
		neg.w	d3
y2gy1:		sub.w	d0,d2
		roxl.b	#1,d5
		tst.w	d2
		bge.s	x2gx1
		neg.w	d2
x2gx1:		move.w	d3,d1
		sub.w	d2,d1
		bge.s	dygdx
		exg	d2,d3
dygdx:		roxl.b	#1,d5
		move.b	Oct_Tab(pc,d5),d5
		add.w	d2,d2

WBlit:		btst	#14,DMACONR(a5)
		bne.s	WBlit

		move.w	d2,BLTBMOD(a5)
		sub.w	d3,d2
		bge.s	signn1
		or.b	#$40,d5
signn1:		move.w	d2,BLTAPTL(a5)
		sub.w	d3,d2
		move.w	d2,BLTAMOD(a5)

		move.w	#$8000,BLTADAT(a5)
		move.w	a2,BLTBDAT(a5)
		move.w	#-1,BLTAFWM(a5)
		and.w	#$000f,d0
		ror.w	#4,d0
		or.w	#$bca,d0
		move.w	d0,BLTCON0(a5)
		move.w	d5,BLTCON1(a5)
		move.l	d4,BLTCPTH(a5)
		move.l	d4,BLTDPTH(a5)
		move.w	#42,BLTCMOD(a5)
		move.w	#42,BLTDMOD(a5)	; Scrwidth in bytes

		lsl.w	#6,d3
		addq.w	#2,d3
		move.w	d3,BLTSIZE(a5)

		rts

Oct_Tab:	dc.b	0*4+1,4*4+1,2*4+1,5*4+1,1*4+1,6*4+1,3*4+1,7*4+1


; Now a routine to rotate PData about the y-axis, ang in d6
; Must have COS base in COSR, SINE base in SINER

YAxis:		moveq	#vert-1,d7	; no. of points to rotate
		lea	PData(pc),a0	; data for points
YAxisLp:	move.w	(a0),d2		; d2=x
		move.w	4(a0),d3	; d3=z
		move.w	(COSR,d6.w),d4	; d4=cos(ang)*128
		move.w	(SINER,d6.w),d5	; d5=sin(ang)*128
		move.w	d2,d0		; d0=x
		muls	d4,d0		; d0=x*cos(ang)*128
		move.w	d3,d1		; d1=z
		muls	d5,d1		; d1=z*sin(ang)*128
		add.w	d1,d0		; d0=128*(x*cos(ang)+z*sin(ang))
		asr.w	#7,d0		; d0=x*cos(ang)+z*sin(ang)
		move.w	d0,(a0)		; x=d0=x*cos(ang)+z*sin(ang)
		muls	d5,d2		; d2=x*sin(ang)*128
		muls	d4,d3		; d3=z*cos(ang)*128
		sub.w	d2,d3		; d3=128*(-x*sin(ang)+z*cos(ang))
		asr.w	#7,d3		; d3=-x*sin(ang)+z*cos(ang)
		move.w	d3,4(a0)	; z=d0=-x*sin(ang)+z*cos(ang)
		addq.l	#6,a0		; Get next coords
		dbf	d7,YAxisLp	; Rotate all vertices
		rts			; Return

; Now a routine to rotate PData about the x-axis, ang in d6
; Must have COS base in COSR, SINE base in SINER

XAxis:		moveq	#vert-1,d7	; No. of points to rotate
		lea	PData(pc),a0	; Coordinate table
XAxisLp:	addq.l	#2,a0		; skip x
		move.w	(a0),d2		; d2=y
		move.w	2(a0),d3	; d3=z
		move.w	(COSR,d6.w),d4	; d4=cos(ang)*128
		move.w	(SINER,d6.w),d5	; d5=sin(ang)*128
		move.w	d2,d0		; d0=y
		muls	d4,d0		; d0=y*cos(ang)*128
		move.w	d3,d1		; d1=z
		muls	d5,d1		; d1=z*sin(ang)*128
		add.w	d1,d0		; d0=128*(y*cos(ang)+z*sin(ang))
		asr.w	#7,d0		; d0=y*cos(ang)+z*sin(ang)
		move.w	d0,(a0)+	; y=d0=y*cos(ang)+z*sin(ang)
		muls	d5,d2		; d2=y*sin(ang)*128
		muls	d4,d3		; d3=z*cos(ang)*128
		sub.w	d2,d3		; d3=128*(-y*sin(ang)+z*cos(ang))
		asr.w	#7,d3		; d3=-y*sin(ang)+z*cos(ang)
		move.w	d3,(a0)+	; z=d3=-y*sin(ang)+z*cos(ang)
		dbf	d7,XAxisLp	; Do all points
		rts


; Now a routine to rotate PData about the z-axis, ang in d6
; Must have COS base in COSR, SINE base in SINER

ZAxis:		moveq	#vert-1,d7	; No. of points to rotate
		lea	PData(pc),a0	; Coordinate table
ZAxisLp:	move.w	(a0),d2		; d2=x
		move.w	2(a0),d3	; d3=y
		move.w	(COSR,d6.w),d4	; d4=cos(ang)*128
		move.w	(SINER,d6.w),d5	; d5=sin(ang)*128
		move.w	d2,d0		; d0=x
		muls	d4,d0		; d0=x*cos(ang)*128
		move.w	d3,d1		; d1=y
		muls	d5,d1		; d1=y*sin(ang)*128
		add.w	d1,d0		; d0=128*(x*cos(ang)+y*sin(ang))
		asr.w	#7,d0		; d0=x*cos(ang)+y*sin(ang)
		move.w	d0,(a0)+	; y=d0=x*cos(ang)+y*sin(ang)
		muls	d5,d2		; d2=x*sin(ang)*128
		muls	d4,d3		; d3=y*cos(ang)*128
		sub.w	d2,d3		; d3=128*(-x*sin(ang)+y*cos(ang))
		asr.w	#7,d3		; d3=-x*sin(ang)+y*cos(ang)
		move.w	d3,(a0)+	; z=d3=-x*sin(ang)+y*cos(ang)
		addq.l	#2,a0		; skip z
		dbf	d7,ZAxisLp	; Do all points
		rts


; Routine to create sine table using cos table

MakeSine:	lea	SINE(pc),a0	; Table to create
		moveq	#0,d6		; Angle in d6
		move.w	#255,d2		; 256 angles to do
GetSin:		move.w	#64<<1,d0	; use 90-sin(x)
		sub.w	d6,d0		; to get equivalent cos
		and.w	#255<<1,d0	; mask negatives to valid range
		move.w	COS(pc,d0.w),(a0)+	; Store in sin table
		addq.w	#2,d6		; increase angle
		dbf	d2,GetSin	; repeat for all possible angles
		rts			; return

COS:		INCBIN	COSDATA.BIN	; only include COS data
SINE:		ds.b	SINE-COS	; leave space for sin table

; Data section. Yawn, yawn, yawn...

; Data for 3D shapes. Vertices are numbered 0,1..

; Data for CP92 lettering

vert:		equ	39

VData:		dc.w	-18,-7,0,-21,-10,0,-27,-10,0,-30,-7,0
		dc.w	-30,7,0,-27,10,0,-21,10,0,-18,7,0		; C
		dc.w	-16,10,0,-10,10,0,-13,10,0,-13,-10,0
		dc.w	-16,-10,0,-5,-10,0,-3,-7,0,-3,-2,0
		dc.w	-5,0,0,-16,0,0					; P
		dc.w	5,10,0,13,10,0,15,7,0,15,-7,0,13,-10,0
		dc.w	6,-10,0,4,-7,0,4,-2,0,6,0,0,13,0,0,15,-2,0	; 9
		dc.w	30,7,0,30,10,0,19,10,0,19,7,0,23,3,0
		dc.w	30,-3,0,30,-7,0,27,-10,0,21,-10,0,19,-7,0	; 2

edge:		equ	33

EData:		dc.w	0,1,1,2,2,3,3,4,4,5,5,6,6,7			; C
		dc.w	8,9,10,11,12,13,13,14,14,15,15,16,16,17		; P
		dc.w	18,19,19,20,20,21,21,22,22,23
		dc.w	23,24,24,25,25,26,26,27,27,28			; 9
		dc.w	29,30,30,31,31,32,32,33,33,34
		dc.w	34,35,35,36,36,37,37,38				; 2


GfxName:	dc.b	"graphics.library",0,0

Copper:		ds.w	12		; 3 bitplanes
		dc.w	$8e,$2981,$90,$f1c1,$92,$38,$94,$d0
		dc.w	$100,$3600,$108,0,$10a,2,$104,$40
		dc.w	$180,0,$182,$888,$184,$55f,$186,$fff

Colours:	dc.w	$a04,$b03,$c02,$d01,$f00,$f10,$f20,$f30,$f40,$f50
		dc.w	$f60,$f70,$f80,$f90,$fa0,$fb0,$fc0,$fd0,$fe0,$ff0
		dc.w	$ef0,$df0,$cf0,$bf0,$af0,$9f0,$8f0,$7f0,$6f0,$5f0
		dc.w	$4f0,$3f0,$2f0,$1f0,$0f0,$0f1,$0f2,$0f3,$0f4,$0f5
		dc.w	$0f6,$0f7,$0f8,$0f9,$0fa,$0fb,$0fc,$0fd,$0fe,$0ff
		dc.w	$0ef,$0df,$0cf,$0bf,$0af,$09f,$08f,$07f,$06f,$05f
		dc.w	$04f,$03f,$02f,$01f,$00e,$10d,$20c,$30b,$40a,$509
		dc.w	$608,$707,$806,$905
		dc.w	0


; Now some graphicsy data

Font:		INCBIN	df1:CHARSET.BIN		; Double height chars

COSH:		INCBIN	COSHOFFS		; Bless you
		dc.w	460
COSHCORR:	dc.w	461

FASTBODY:	INCBIN	FAST.BODY

ScrollText:
 dc.b	"Captain Paranoia presents   -   "
 dc.b	"Another Crappy ST Port.   Get your act together "
 dc.b	"Ocean, and if you can't manage to write a game for the "
 dc.b	"Amiga at least don't charge 10 quid extra for it.       "
 dc.b	"Greetings to (alphabetical order)   "
 dc.b	"Beefer, Big-Byte, Dragonmaster, Frantic Daniel, Greg, "
 dc.b	"Rimmer/Endless Piracy, Smit, Sof-T, Spike, The Mad Mage, "
 dc.b	"The Slayer, The Star Child, Whinge etc...   "

 dc.b	"Scrolltext wraps.      ",0


ScrollPos:	ds.l	1
ScrollCnt:	ds.w	1
ScrollHeight:	ds.w	1
CopSave:	ds.l	1
DMASave:	ds.w	1
Ang:		ds.w	1
ErzFlag:	ds.w	1

PData:		ds.w	6*vert		; Positions
DData:		ds.w	4*vert		; Display positions

		section	mem,BSS_C

RealCopper:	ds.l	19		; Actual copperlist
		ds.w	800		; Space for waits

screen:		ds.b	8002		; FAST plane
screen2:	ds.b	8400		; Scrolltext plane
screen3:	ds.b	8002		; FAST plane 2
AddrTable:	ds.l	41
screensize	equ	AddrTable-screen

; End of CP vector intro



